#Module-Specific definitions
%define mod_version 3.1.4
%define mod_name mod_python
%define mod_conf 16_%{mod_name}.conf
%define mod_so %{mod_name}.so

%define apache_version 2.0.54

#TODO split doc from main package

# Standard Module Definitions
%define name apache-%{mod_name}
%define version %{apache_version}_%{mod_version}

Summary:	An embedded Python interpreter for the apache web server
Name:		%{name}
Version:	%{version}
Release:	%mkrel 2
Group:		System/Servers
License:	Apache License
URL:		http://www.modpython.org/
Source0:	%{mod_name}-%{mod_version}.tgz
Source1:	%{mod_name}-%{mod_version}.tgz.asc
Source2:	%{mod_conf}.bz2
Patch1:		mod_python-3.0.3-version.patch.bz2
Patch3:		mod_python-3.1.2b-mutex_dir.diff.bz2
Patch4:		mod_python-3.1.3-maxlocks.patch.bz2
Patch5:		mod_python-20020610-gsr.patch.bz2
Patch6:		mod_python-20020722-lib64.patch.bz2
BuildPrereq:	python
BuildPrereq:	python-devel
BuildPrereq:	flex
BuildRequires:	automake1.7
BuildRequires:	autoconf2.5
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):	apache-conf >= 2.0.54
Requires(pre):	apache >= %{apache_version}
Requires:	apache-conf >= 2.0.54
Requires:	apache >= %{apache_version}
BuildRequires:	apache-devel >= %{apache_version}
BuildRequires:	file
Provides:	mod_python apache2-mod_python
Obsoletes:	mod_python apache2-mod_python
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Mod_python is a module that embeds the Python language interpreter within
the apache server, allowing Apache handlers to be written in Python.

Mod_python brings together the versatility of Python and the power of
the Apache Web server for a considerable boost in flexibility and
performance over the traditional CGI approach.

%prep

%setup -q -n %{mod_name}-%{mod_version}
%patch1 -p0
%patch3 -p0
%patch4 -p1 -b .maxlocks
%patch5 -p0 -b .gsr
%patch6 -p1 -b .lib64

for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -r $i; fi >&/dev/null
done

# strip away annoying ^M
find . -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
find . -type f|xargs file|grep 'text'|cut -d: -f1|xargs perl -p -i -e 's/\r//'

%build
export WANT_AUTOCONF_2_5=1
rm -f configure
libtoolize --copy --force && aclocal-1.7 && autoconf --force && autoheader

%configure2_5x \
    --with-apxs=%{_sbindir}/apxs

make OPT="`%{_sbindir}/apxs -q CFLAGS` -fPIC -DEAPI"

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_libdir}/apache-extramodules
install -d %{buildroot}%{_sysconfdir}/httpd/modules.d

export EXCLUDE_FROM_STRIP=%{buildroot}%{_libdir}/apache-extramodules/%{mod_so}

# we only want to provide png files...
pushd doc-html
    for i in `find -name "*.gif"`; do
	rm -f $i
    done

    find -type f -name "*.html" | xargs perl -p -i -e "s|\.gif|\.png|g"
popd

make DESTDIR=%{buildroot} install

# move the module in place
mv %{buildroot}%{_libdir}/apache/%{mod_so} %{buildroot}%{_libdir}/apache-extramodules

bzcat %{SOURCE2} > %{buildroot}%{_sysconfdir}/httpd/modules.d/%{mod_conf}

install -d %{buildroot}%{_var}/www/html/addon-modules
ln -s ../../../..%{_docdir}/%{name}-%{version} %{buildroot}%{_var}/www/html/addon-modules/%{name}-%{version}

# fix location for mutex files
install -d %{buildroot}%{_var}/cache/httpd/mod_python

%post
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc doc-html/* CREDITS NEWS README examples test
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/%{mod_conf}
%attr(0755,root,root) %{_libdir}/apache-extramodules/%{mod_so}
%{_var}/www/html/addon-modules/*
%{_libdir}/python*/site-packages/mod_python/
%attr(0755,apache,apache) %dir %{_var}/cache/httpd/mod_python

%changelog
* Sat Jul 30 2005 Oden Eriksson <oeriksson@mandriva.com> 2.0.54_3.1.4-2mdk
- fix deps

* Thu Jun 02 2005 Oden Eriksson <oeriksson@mandriva.com> 2.0.54_3.1.4-1mdk
- rename the package
- the conf.d directory is renamed to modules.d
- use new rpm-4.4.x pre,post magic

* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-4mdk
- use the %%mkrel macro

* Mon Feb 28 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-3mdk
- fix %%post and %%postun to prevent double restarts
- fix bug #6574

* Wed Feb 16 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-2mdk
- spec file cleanups, remove the ADVX-build stuff

* Fri Feb 11 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.4-1mdk
- rebuilt for apache 2.0.53

* Tue Feb  8 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_3.1.3-1mdk
- rebuilt for apache 2.0.53

* Sat Dec 04 2004 Michael Scherer <misc@mandrake.org> 2.0.52_3.1.3-3mdk
- Rebuild for new python

* Sat Nov 27 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_3.1.3-2mdk
- added P4,P5,P6 from fedora
- use the %%configure2_5x macro
- fix deps

* Tue Sep 28 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_3.1.3-1mdk
- built for apache 2.0.52

* Thu Sep 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.51_3.1.3-1mdk
- built for apache 2.0.51

* Mon Jul 12 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_3.1.3-1mdk
- built for apache 2.0.50
- remove redundant provides

* Fri Jun 11 2004 Michael Scherer <misc@mandrake.org> 2.0.49_3.1.3-1mdk
- rebuild for new apache
 
* Mon Mar 01 2004 Michael Scherer <misc@mandrake.org> 2.0.48_3.1.3-1mdk 
- 3.1.3
- added a psp config example
- [DIRM]

* Wed Nov 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.48_3.1.2b-1mdk
- built for apache 2.0.48

* Sun Nov 02 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.1.2b-1mdk
- 3.1.2b
- drop P2 & P4
- fix cache dir

* Tue Sep 23 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.1.0a-2mdk
- added P4 (may fix #5629)

* Sat Aug 30 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.1.0a-1mdk
- 3.1.0a
- added P2 + buildrequires flex
- added P3 + mutex dir + fixed S2
- new license
- misc spec file fixes

* Thu Aug 07 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-4mdk
- rebuild against new python

* Fri Jul 25 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-3mdk
- found the problem at last..., the %{mod_so} file won't work stripped...

* Thu Jul 24 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-2mdk
- don't install the compiled stuff in python lib (it's messed up)

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_3.0.3-1mdk
- rebuilt against latest apache2, requires and buildrequires

* Mon Jul 07 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_3.0.3-2mdk
- fix #4140 (P0)

* Sat May 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_3.0.3-1mdk
- rebuilt for apache v2.0.46
- buildprereq ADVX-build >= 9.2

* Tue Apr 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.45_3.0.3-1mdk
- cosmetic rebuild for apache v2.0.45 

* Sun Apr 06 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.44_3.0.3-1mdk
- 3.0.3
- added the pgp sig file
- fix P0
- misc spec file fixes

* Tue Jan 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.44_3.0.1-1mdk
- rebuilt for apache v2.0.44

* Mon Jan 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-4mdk
- fix buildrequires apache-devel >= 2.0.53-1mdk, as 
  pointed out by Olivier Thauvin

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-3mdk
- rebuilt against rebuilt buildrequires

* Mon Jan 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-2mdk
- Rebuilt with the new apache-devel that uses /usr/sbin/apxs2 and
  /usr/include/apache2

* Wed Nov 27 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.1-1mdk
- new major version
- drop all patches, add P0 (a simple DESTDIR patch)

* Sat Nov 02 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.0-3mdk
- rebuilt for/against apache2 where dependencies has changed in apr

* Tue Oct 22 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.0-2mdk
- extra modules needs to be loaded _before_ mod_ssl, mod_php and mod_perl
  in order to show up in the server string...

* Fri Oct 04 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_3.0.0-1mdk
- rebuilt for/against new apache2 version 2.0.43 (even though 2.0.42 and 
  2.0.43 are binary compatible, we have to consider rpm dependencies)
- sanitize rpm package versioning

* Thu Sep 26 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.42_3.0.0-4mdk
- rebuilt against new apache v2.0.42

* Wed Sep  3 2002 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.40ADVX_3.0.0-3mdk
- Obsoletes mod_python

* Wed Sep  3 2002 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.40ADVX_3.0.0-2mdk
- Comply with ADVX policy at http://advx.org/devel/policy.php

* Sun Sep  1 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 3.0.0-1mdk
- initial cooker contrib, ripped from RH, adapted for ML

